/* Problem URL: https://codeforces.com/gym/105446/problem/F */

#include <bits/stdc++.h>

using namespace std;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, l, k;
    cin >> n >> l >> k;

    V<bool> vis(n);

    V<string> rev(n);

    vvi s(n, vi(l));

    rep(i, n) {
        string fds;
        cin >> fds;
        rev[i] = fds;

        rep(j, l) {
            cin >> s[i][j];
        }
    }

    auto diff = [&](int i, int j) {
        int ans = 0;
        rep(f, l) {
            ans += abs(s[i][f] - s[j][f]);
        }

        return ans;
    };

    vi dis(n, INT32_MAX);

    vi choices;
    int now = 0;
    int maximal = 0;

    nrep(i, 1, n) {
        int d = diff(0, i);

        if (d > maximal) {
            maximal = d;
            now = i;
        }
    }

    choices.push_back(now);

    nrep(i, 1, k) {
        now = 0;
        maximal = 0;
        rep(j, n) {
            rmin(dis[j], diff(choices.back(), j));

            if (dis[j] > maximal) {
                maximal = dis[j];
                now = j;
            }
        }

        choices.push_back(now);
    }

    repv(i, choices) {
        cout << rev[i] << '\n';
    }
}
